#pragma clang diagnostic ignored "-Wmissing-prototypes"
#pragma clang diagnostic ignored "-Wmissing-braces"

#include <metal_stdlib>
#include <simd/simd.h>

using namespace metal;

template<typename T, size_t Num>
struct spvUnsafeArray
{
    T elements[Num ? Num : 1];
    
    thread T& operator [] (size_t pos) thread
    {
        return elements[pos];
    }
    constexpr const thread T& operator [] (size_t pos) const thread
    {
        return elements[pos];
    }
    
    device T& operator [] (size_t pos) device
    {
        return elements[pos];
    }
    constexpr const device T& operator [] (size_t pos) const device
    {
        return elements[pos];
    }
    
    constexpr const constant T& operator [] (size_t pos) const constant
    {
        return elements[pos];
    }
    
    threadgroup T& operator [] (size_t pos) threadgroup
    {
        return elements[pos];
    }
    constexpr const threadgroup T& operator [] (size_t pos) const threadgroup
    {
        return elements[pos];
    }
};

struct buffer_t
{
    spvUnsafeArray<float4, 3> u_DirLightsDirection;
    float4x4 u_DirLight0ShadowMatrix;
    float4 u_DirLight0ShadowColor;
    float u_DirLight0ShadowBias;
    float2 u_DirLight0ShadowTextureSize;
    float u_DirLight0ShadowSoft;
    float u_DirLight0ShadowSoftness;
    float u_DirLight0SelfShadowGradient;
    float u_DirLight0ShadowStrength;
    spvUnsafeArray<float, 3> u_DirLightsEnabled;
    float u_DirLightNum;
};

struct main0_out
{
    float4 glResult [[color(0)]];
};

struct main0_in
{
    float3 g_worldPos [[user(locn0)]];
    float3 g_worldNormal [[user(locn1)]];
};

fragment main0_out main0(main0_in in [[stage_in]], constant buffer_t& buffer, texture2d<float> u_DirLight0ShadowTexture [[texture(0)]], sampler u_DirLight0ShadowTextureSmplr [[sampler(0)]])
{
    main0_out out = {};
    if ((buffer.u_DirLightsEnabled[0] * step(0.5, buffer.u_DirLightNum)) > 0.5)
    {
        float4 _664;
        do
        {
            float _412 = fast::max(dot(fast::normalize(in.g_worldNormal), -buffer.u_DirLightsDirection[0].xyz), 0.0);
            float4 _419 = buffer.u_DirLight0ShadowMatrix * float4(in.g_worldPos, 1.0);
            float3 _425 = _419.xyz / float3(_419.w);
            float _427 = _425.x;
            bool _428 = _427 < 0.0;
            bool _435;
            if (!_428)
            {
                _435 = _425.y < 0.0;
            }
            else
            {
                _435 = _428;
            }
            bool _442;
            if (!_435)
            {
                _442 = _427 > 1.0;
            }
            else
            {
                _442 = _435;
            }
            bool _449;
            if (!_442)
            {
                _449 = _425.y > 1.0;
            }
            else
            {
                _449 = _442;
            }
            if (_449)
            {
                _664 = float4(buffer.u_DirLight0ShadowColor.xyz, 1.0);
                break;
            }
            float _460 = fast::clamp(_425.z, 0.0, 1.0);
            float _470 = fast::clamp(buffer.u_DirLight0ShadowBias + fast::clamp(tan(acos(_412)) * 0.001000000047497451305389404296875, 0.0, 0.001000000047497451305389404296875), 0.0, 1.0);
            float2 _472 = float2(1.0) / buffer.u_DirLight0ShadowTextureSize;
            float _653;
            float _656;
            if (buffer.u_DirLight0ShadowSoft > 0.0)
            {
                float _651;
                float _652;
                _652 = 0.0;
                _651 = 0.0;
                float _662;
                float _663;
                for (int _650 = 0; _650 < 4; _652 = _663, _651 = _662, _650++)
                {
                    float _482 = float(_650);
                    _663 = _652;
                    _662 = _651;
                    for (int _658 = 0; _658 < 4; )
                    {
                        float _489 = float(_658);
                        float2 _491 = _425.xy;
                        float _509 = sqrt(_482 + fract(sin(dot(_491 + float2(_482, _489), float2(12.98980045318603515625, 78.233001708984375))) * 43758.546875));
                        float _516 = (_489 + fract(sin(dot(_491 + float2(_482 * 2.0, _489 * 3.0), float2(12.98980045318603515625, 78.233001708984375))) * 43758.546875)) * 0.392698764801025390625;
                        float4 _534 = u_DirLight0ShadowTexture.sample(u_DirLight0ShadowTextureSmplr, fma(float2(_509 * cos(_516), _509 * sin(_516)) * buffer.u_DirLight0ShadowSoftness, _472, _491));
                        float _543 = float(_460 <= (dot(_534, float4(1.52587890625e-05, 0.00390625, 1.0, 0.0)) + _470));
                        _663 += fast::max(_534.w, _543);
                        _662 += _543;
                        _658++;
                        continue;
                    }
                }
                _656 = _652 * 0.0625;
                _653 = _651 * 0.0625;
            }
            else
            {
                float4 _569 = u_DirLight0ShadowTexture.sample(u_DirLight0ShadowTextureSmplr, _425.xy);
                float _578 = float(_460 <= (dot(_569, float4(1.52587890625e-05, 0.00390625, 1.0, 0.0)) + _470));
                _656 = fast::max(_569.w, _578);
                _653 = _578;
            }
            float _654;
            if (buffer.u_DirLight0SelfShadowGradient > 9.9999997473787516355514526367188e-05)
            {
                _654 = fast::min(fast::clamp((_412 - 0.00872653536498546600341796875) * buffer.u_DirLight0SelfShadowGradient, 0.0, 1.0), _653);
            }
            else
            {
                _654 = _653;
            }
            float _657;
            if (_654 < 1.0)
            {
                _657 = mix(1.0, _654, buffer.u_DirLight0ShadowStrength * _656);
            }
            else
            {
                _657 = _654;
            }
            _664 = float4(buffer.u_DirLight0ShadowColor.xyz, _657);
            break;
        } while(false);
        out.glResult = float4(_664.xyz, 1.0 - _664.w);
    }
    else
    {
        out.glResult = float4(0.0);
    }
    return out;
}

