#include <metal_stdlib>
#include <simd/simd.h>

using namespace metal;

struct buffer_t
{
    float4x4 u_Model;
    float4x4 u_TransposeInvModel;
    float4x4 u_MVP;
};

struct main0_out
{
    float2 g_vary_uv0 [[user(locn0)]];
    float3 g_vary_WorldPosition [[user(locn1)]];
    float3 g_vary_WorldNormal [[user(locn2)]];
    float4 v_gl_pos [[user(locn3)]];
    float4 gl_Position [[position]];
};

struct main0_in
{
    float3 attPosition [[attribute(0)]];
    float3 attNormal [[attribute(1)]];
    float2 attTexcoord0 [[attribute(2)]];
};

vertex main0_out main0(main0_in in [[stage_in]], constant buffer_t& buffer)
{
    main0_out out = {};
    float4 _24 = float4(in.attPosition, 1.0);
    out.g_vary_uv0 = in.attTexcoord0;
    out.g_vary_WorldPosition = (buffer.u_Model * _24).xyz;
    out.g_vary_WorldNormal = (buffer.u_TransposeInvModel * float4(in.attNormal, 0.0)).xyz;
    out.gl_Position = buffer.u_MVP * _24;
    out.v_gl_pos = out.gl_Position;
    out.gl_Position.z = (out.gl_Position.z + out.gl_Position.w) * 0.5;       // Adjust clip-space for Metal
    return out;
}

