#pragma clang diagnostic ignored "-Wmissing-prototypes"
#pragma clang diagnostic ignored "-Wmissing-braces"

#include <metal_stdlib>
#include <simd/simd.h>

using namespace metal;

template<typename T, size_t Num>
struct spvUnsafeArray
{
    T elements[Num ? Num : 1];
    
    thread T& operator [] (size_t pos) thread
    {
        return elements[pos];
    }
    constexpr const thread T& operator [] (size_t pos) const thread
    {
        return elements[pos];
    }
    
    device T& operator [] (size_t pos) device
    {
        return elements[pos];
    }
    constexpr const device T& operator [] (size_t pos) const device
    {
        return elements[pos];
    }
    
    constexpr const constant T& operator [] (size_t pos) const constant
    {
        return elements[pos];
    }
    
    threadgroup T& operator [] (size_t pos) threadgroup
    {
        return elements[pos];
    }
    constexpr const threadgroup T& operator [] (size_t pos) const threadgroup
    {
        return elements[pos];
    }
};

struct buffer_t
{
    float4 u_WorldSpaceCameraPos;
    spvUnsafeArray<float, 3> u_DirLightsEnabled;
    float u_DirLightNum;
    spvUnsafeArray<float4, 3> u_DirLightsDirection;
    spvUnsafeArray<float4, 3> u_DirLightsColor;
    spvUnsafeArray<float, 3> u_DirLightsIntensity;
    spvUnsafeArray<float, 2> u_PointLightsEnabled;
    float u_PointLightNum;
    spvUnsafeArray<float4, 2> u_PointLightsPosition;
    spvUnsafeArray<float4, 2> u_PointLightsColor;
    spvUnsafeArray<float, 2> u_PointLightsIntensity;
    spvUnsafeArray<float, 2> u_PointLightsAttenRangeInv;
    spvUnsafeArray<float, 2> u_SpotLightsEnabled;
    float u_SpotLightNum;
    spvUnsafeArray<float4, 2> u_SpotLightsPosition;
    spvUnsafeArray<float4, 2> u_SpotLightsColor;
    spvUnsafeArray<float, 2> u_SpotLightsIntensity;
    spvUnsafeArray<float, 2> u_SpotLightsAttenRangeInv;
    spvUnsafeArray<float4, 2> u_SpotLightsDirection;
    spvUnsafeArray<float, 2> u_SpotLightsOuterAngleCos;
    spvUnsafeArray<float, 2> u_SpotLightsInnerAngleCos;
    float _AmbientIntensity;
    float _AmbientRotation;
    float4 _AlbedoColor;
    float _Metallic;
    float _Roughness;
};

constant float _6659 = {};

struct main0_out
{
    float4 glResult [[color(0)]];
};

struct main0_in
{
    float3 v_posWS [[user(locn0)]];
    float3 v_nDirWS [[user(locn1)]];
};

fragment main0_out main0(main0_in in [[stage_in]], constant buffer_t& buffer, texture2d<float> _AmbientTexture [[texture(0)]], sampler _AmbientTextureSmplr [[sampler(0)]])
{
    main0_out out = {};
    float3 _2204 = float3(pow(buffer._AlbedoColor.x, 2.2000000476837158203125), pow(buffer._AlbedoColor.y, 2.2000000476837158203125), pow(buffer._AlbedoColor.z, 2.2000000476837158203125));
    float3 _2081 = fast::normalize(in.v_nDirWS);
    float _2440 = fast::clamp(buffer._Metallic, 0.0, 1.0);
    float _2339 = fast::clamp(buffer._Roughness, 0.07999999821186065673828125, 1.0);
    float _2445 = _2339 * _2339;
    float _2450 = _2445 * _2445;
    float3 _2363 = _2204 * (0.959999978542327880859375 * (1.0 - _2440));
    float3 _2370 = mix(float3(0.039999999105930328369140625), _2204, float3(_2440));
    float3 _2405 = fast::normalize(buffer.u_WorldSpaceCameraPos.xyz - in.v_posWS);
    float3 _6492;
    if (dot(_2405, _2081) < 0.0)
    {
        _6492 = reflect(_2405, _2081);
    }
    else
    {
        _6492 = _2405;
    }
    float3 _2431 = fast::normalize(reflect(-_6492, _2081));
    float _2473 = fast::max(0.0, dot(_2081, _6492));
    float _2496 = fast::min(1.0 + dot(_2431, _2081), 1.0);
    float _2502 = fast::clamp(pow(_2473 + 1.0, exp2(fma(-16.0, _2339, -1.0))), 0.0, 1.0) * (_2496 * _2496);
    float _2566 = buffer.u_DirLightsEnabled[0] * step(0.5, buffer.u_DirLightNum);
    float3 _2573 = fast::normalize(-buffer.u_DirLightsDirection[0].xyz);
    float _2585 = buffer.u_DirLightsIntensity[0] * _2566;
    float _2600 = buffer.u_DirLightsEnabled[1] * step(1.5, buffer.u_DirLightNum);
    float3 _2607 = fast::normalize(-buffer.u_DirLightsDirection[1].xyz);
    float _2619 = buffer.u_DirLightsIntensity[1] * _2600;
    float _2634 = buffer.u_DirLightsEnabled[2] * step(2.5, buffer.u_DirLightNum);
    float3 _2641 = fast::normalize(-buffer.u_DirLightsDirection[2].xyz);
    float _2653 = buffer.u_DirLightsIntensity[2] * _2634;
    float _2675 = buffer.u_PointLightsEnabled[0] * step(0.5, buffer.u_PointLightNum);
    float3 _2683 = buffer.u_PointLightsPosition[0].xyz - in.v_posWS;
    float _2685 = length(_2683);
    float3 _2689 = _2683 / float3(_2685);
    float _2701 = buffer.u_PointLightsIntensity[0] * _2675;
    float _2707 = _2685 * buffer.u_PointLightsAttenRangeInv[0];
    float _2729 = _2707 * _2707;
    float _2736 = fast::clamp(fma(-_2729, _2729, 1.0), 0.0, 1.0);
    float3 _2721 = float3(((_2736 * _2736) * fma(_2707, _2707, 1.0)) * 0.25);
    float _2765 = buffer.u_PointLightsEnabled[1] * step(1.5, buffer.u_PointLightNum);
    float3 _2773 = buffer.u_PointLightsPosition[1].xyz - in.v_posWS;
    float _2775 = length(_2773);
    float3 _2779 = _2773 / float3(_2775);
    float _2791 = buffer.u_PointLightsIntensity[1] * _2765;
    float _2797 = _2775 * buffer.u_PointLightsAttenRangeInv[1];
    float _2819 = _2797 * _2797;
    float _2826 = fast::clamp(fma(-_2819, _2819, 1.0), 0.0, 1.0);
    float3 _2811 = float3(((_2826 * _2826) * fma(_2797, _2797, 1.0)) * 0.25);
    float _2857 = buffer.u_SpotLightsEnabled[0] * step(0.5, buffer.u_SpotLightNum);
    float3 _2865 = buffer.u_SpotLightsPosition[0].xyz - in.v_posWS;
    float _2867 = length(_2865);
    float3 _2871 = _2865 / float3(_2867);
    float _2883 = buffer.u_SpotLightsIntensity[0] * _2857;
    float _2889 = _2867 * buffer.u_SpotLightsAttenRangeInv[0];
    float _2932 = _2889 * _2889;
    float _2939 = fast::clamp(fma(-_2932, _2932, 1.0), 0.0, 1.0);
    float3 _2924 = float3((((_2939 * _2939) * fma(_2889, _2889, 1.0)) * 0.25) * smoothstep(buffer.u_SpotLightsOuterAngleCos[0], buffer.u_SpotLightsInnerAngleCos[0], fast::max(0.0, dot(_2871, fast::normalize(-buffer.u_SpotLightsDirection[0].xyz)))));
    float _2970 = buffer.u_SpotLightsEnabled[1] * step(1.5, buffer.u_SpotLightNum);
    float3 _2978 = buffer.u_SpotLightsPosition[1].xyz - in.v_posWS;
    float _2980 = length(_2978);
    float3 _2984 = _2978 / float3(_2980);
    float _2996 = buffer.u_SpotLightsIntensity[1] * _2970;
    float _3002 = _2980 * buffer.u_SpotLightsAttenRangeInv[1];
    float _3045 = _3002 * _3002;
    float _3052 = fast::clamp(fma(-_3045, _3045, 1.0), 0.0, 1.0);
    float3 _3037 = float3((((_3052 * _3052) * fma(_3002, _3002, 1.0)) * 0.25) * smoothstep(buffer.u_SpotLightsOuterAngleCos[1], buffer.u_SpotLightsInnerAngleCos[1], fast::max(0.0, dot(_2984, fast::normalize(-buffer.u_SpotLightsDirection[1].xyz)))));
    float3 _3324 = fast::normalize(_2081);
    float _3327 = -_3324.z;
    float _3329 = _3324.x;
    float _3336 = acos(_3324.y);
    float _3342 = fma(fma((_3329 < 0.0) ? (-1.0) : 1.0, acos(fast::clamp(_3327 / length(float2(_3329, _3327)), -1.0, 1.0)), -1.57079637050628662109375), 0.15915493667125701904296875, buffer._AmbientRotation);
    float _3351 = fract((_3342 + floor(_3342)) + 1.0);
    float2 _6251 = float2(_6659, _3336 * 0.3183098733425140380859375);
    _6251.x = _3351;
    float _3379 = floor(7.0);
    float2 _6499;
    float2 _6507;
    if (abs(_3379) < 0.001000000047497451305389404296875)
    {
        _6507 = float2(fma(_3351, 0.99609375, 0.001953125) * 0.5, fma(fma(_3336, 0.315823078155517578125, 0.00390625), 0.25, 0.5));
        _6499 = float2(fma(_3351, 0.998046875, 0.0009765625), fma(_3336, 0.3170664608478546142578125, 0.001953125) * 0.5);
    }
    else
    {
        float2 _6500;
        float2 _6508;
        if (abs(_3379 - 1.0) < 0.001000000047497451305389404296875)
        {
            float _3432 = fma(_3351, 0.99609375, 0.001953125);
            float _3442 = fma(fma(_3336, 0.315823078155517578125, 0.00390625), 0.25, 0.5);
            _6508 = float2(fma(_3432, 0.5, 0.5), _3442);
            _6500 = float2(_3432 * 0.5, _3442);
        }
        else
        {
            float2 _6501;
            float2 _6509;
            if (abs(_3379 - 2.0) < 0.001000000047497451305389404296875)
            {
                float _3470 = fma(_3351, 0.99609375, 0.001953125);
                float _3478 = fma(_3336, 0.315823078155517578125, 0.00390625);
                _6509 = float2(_3470 * 0.5, fma(_3478, 0.25, 0.75));
                _6501 = float2(fma(_3470, 0.5, 0.5), fma(_3478, 0.25, 0.5));
            }
            else
            {
                float2 _6502;
                float2 _6510;
                if (abs(_3379 - 3.0) < 0.001000000047497451305389404296875)
                {
                    _6510 = float2(fma(fma(_3351, 0.9921875, 0.00390625), 0.25, 0.5), fma(fma(_3336, 0.3133362829685211181640625, 0.0078125), 0.125, 0.75));
                    _6502 = float2(fma(_3351, 0.99609375, 0.001953125) * 0.5, fma(fma(_3336, 0.315823078155517578125, 0.00390625), 0.25, 0.75));
                }
                else
                {
                    float2 _6503;
                    float2 _6511;
                    if (abs(_3379 - 4.0) < 0.001000000047497451305389404296875)
                    {
                        float _3546 = fma(_3351, 0.9921875, 0.00390625);
                        float _3556 = fma(fma(_3336, 0.3133362829685211181640625, 0.0078125), 0.125, 0.75);
                        _6511 = float2(fma(_3546, 0.25, 0.75), _3556);
                        _6503 = float2(fma(_3546, 0.25, 0.5), _3556);
                    }
                    else
                    {
                        float2 _6504;
                        float2 _6512;
                        if (abs(_3379 - 5.0) < 0.001000000047497451305389404296875)
                        {
                            float _3584 = fma(_3351, 0.9921875, 0.00390625);
                            float _3592 = fma(_3336, 0.3133362829685211181640625, 0.0078125);
                            _6512 = float2(fma(_3584, 0.25, 0.5), fma(_3592, 0.125, 0.875));
                            _6504 = float2(fma(_3584, 0.25, 0.75), fma(_3592, 0.125, 0.75));
                        }
                        else
                        {
                            float2 _6505;
                            float2 _6513;
                            if (abs(_3379 - 6.0) < 0.001000000047497451305389404296875)
                            {
                                float _3622 = fma(_3351, 0.9921875, 0.00390625);
                                float _3632 = fma(fma(_3336, 0.3133362829685211181640625, 0.0078125), 0.125, 0.875);
                                _6513 = float2(fma(_3622, 0.25, 0.75), _3632);
                                _6505 = float2(fma(_3622, 0.25, 0.5), _3632);
                            }
                            else
                            {
                                float2 _6514;
                                if (abs(_3379 - 7.0) < 0.001000000047497451305389404296875)
                                {
                                    _6514 = float2(fma(fma(_3351, 0.9921875, 0.00390625), 0.25, 0.75), fma(fma(_3336, 0.3133362829685211181640625, 0.0078125), 0.125, 0.875));
                                }
                                else
                                {
                                    _6514 = _6251;
                                }
                                _6513 = _6514;
                                _6505 = _6514;
                            }
                            _6512 = _6513;
                            _6504 = _6505;
                        }
                        _6511 = _6512;
                        _6503 = _6504;
                    }
                    _6510 = _6511;
                    _6502 = _6503;
                }
                _6509 = _6510;
                _6501 = _6502;
            }
            _6508 = _6509;
            _6500 = _6501;
        }
        _6507 = _6508;
        _6499 = _6500;
    }
    float4 _3698 = _AmbientTexture.sample(_AmbientTextureSmplr, _6499);
    float4 _3701 = _AmbientTexture.sample(_AmbientTextureSmplr, _6507);
    float4 _3704 = mix(_3698, _3701, float4(7.0 - _3379));
    float3 _3116 = ((((_3704.xyz / float3(_3704.w)) * _2363) * fast::max(float3(1.0), ((((((_2363 * 2.040400028228759765625) - float3(0.3323999941349029541015625)) * 1.0) + ((_2363 * (-4.79510021209716796875)) + float3(0.6417000293731689453125))) * 1.0) + ((_2363 * 2.755199909210205078125) + float3(0.69029998779296875))) * 1.0)) * buffer._AmbientIntensity) * 1.0;
    float _3767 = _2339 - 0.07999999821186065673828125;
    float3 _3807 = fast::normalize(mix(_2431, _2081, float3(_2339 * _2445)));
    float _3810 = -_3807.z;
    float _3812 = _3807.x;
    float _3819 = acos(_3807.y);
    float _3825 = fma(fma((_3812 < 0.0) ? (-1.0) : 1.0, acos(fast::clamp(_3810 / length(float2(_3812, _3810)), -1.0, 1.0)), -1.57079637050628662109375), 0.15915493667125701904296875, buffer._AmbientRotation);
    float _3834 = fract((_3825 + floor(_3825)) + 1.0);
    float2 _6366 = float2(_6659, _3819 * 0.3183098733425140380859375);
    _6366.x = _3834;
    float _3862 = floor(_3767 * 7.0);
    float2 _6532;
    float2 _6540;
    if (abs(_3862) < 0.001000000047497451305389404296875)
    {
        _6540 = float2(fma(_3834, 0.99609375, 0.001953125) * 0.5, fma(fma(_3819, 0.315823078155517578125, 0.00390625), 0.25, 0.5));
        _6532 = float2(fma(_3834, 0.998046875, 0.0009765625), fma(_3819, 0.3170664608478546142578125, 0.001953125) * 0.5);
    }
    else
    {
        float2 _6533;
        float2 _6541;
        if (abs(_3862 - 1.0) < 0.001000000047497451305389404296875)
        {
            float _3915 = fma(_3834, 0.99609375, 0.001953125);
            float _3925 = fma(fma(_3819, 0.315823078155517578125, 0.00390625), 0.25, 0.5);
            _6541 = float2(fma(_3915, 0.5, 0.5), _3925);
            _6533 = float2(_3915 * 0.5, _3925);
        }
        else
        {
            float2 _6534;
            float2 _6542;
            if (abs(_3862 - 2.0) < 0.001000000047497451305389404296875)
            {
                float _3953 = fma(_3834, 0.99609375, 0.001953125);
                float _3961 = fma(_3819, 0.315823078155517578125, 0.00390625);
                _6542 = float2(_3953 * 0.5, fma(_3961, 0.25, 0.75));
                _6534 = float2(fma(_3953, 0.5, 0.5), fma(_3961, 0.25, 0.5));
            }
            else
            {
                float2 _6535;
                float2 _6543;
                if (abs(_3862 - 3.0) < 0.001000000047497451305389404296875)
                {
                    _6543 = float2(fma(fma(_3834, 0.9921875, 0.00390625), 0.25, 0.5), fma(fma(_3819, 0.3133362829685211181640625, 0.0078125), 0.125, 0.75));
                    _6535 = float2(fma(_3834, 0.99609375, 0.001953125) * 0.5, fma(fma(_3819, 0.315823078155517578125, 0.00390625), 0.25, 0.75));
                }
                else
                {
                    float2 _6536;
                    float2 _6544;
                    if (abs(_3862 - 4.0) < 0.001000000047497451305389404296875)
                    {
                        float _4029 = fma(_3834, 0.9921875, 0.00390625);
                        float _4039 = fma(fma(_3819, 0.3133362829685211181640625, 0.0078125), 0.125, 0.75);
                        _6544 = float2(fma(_4029, 0.25, 0.75), _4039);
                        _6536 = float2(fma(_4029, 0.25, 0.5), _4039);
                    }
                    else
                    {
                        float2 _6537;
                        float2 _6545;
                        if (abs(_3862 - 5.0) < 0.001000000047497451305389404296875)
                        {
                            float _4067 = fma(_3834, 0.9921875, 0.00390625);
                            float _4075 = fma(_3819, 0.3133362829685211181640625, 0.0078125);
                            _6545 = float2(fma(_4067, 0.25, 0.5), fma(_4075, 0.125, 0.875));
                            _6537 = float2(fma(_4067, 0.25, 0.75), fma(_4075, 0.125, 0.75));
                        }
                        else
                        {
                            float2 _6538;
                            float2 _6546;
                            if (abs(_3862 - 6.0) < 0.001000000047497451305389404296875)
                            {
                                float _4105 = fma(_3834, 0.9921875, 0.00390625);
                                float _4115 = fma(fma(_3819, 0.3133362829685211181640625, 0.0078125), 0.125, 0.875);
                                _6546 = float2(fma(_4105, 0.25, 0.75), _4115);
                                _6538 = float2(fma(_4105, 0.25, 0.5), _4115);
                            }
                            else
                            {
                                float2 _6547;
                                if (abs(_3862 - 7.0) < 0.001000000047497451305389404296875)
                                {
                                    _6547 = float2(fma(fma(_3834, 0.9921875, 0.00390625), 0.25, 0.75), fma(fma(_3819, 0.3133362829685211181640625, 0.0078125), 0.125, 0.875));
                                }
                                else
                                {
                                    _6547 = _6366;
                                }
                                _6546 = _6547;
                                _6538 = _6547;
                            }
                            _6545 = _6546;
                            _6537 = _6538;
                        }
                        _6544 = _6545;
                        _6536 = _6537;
                    }
                    _6543 = _6544;
                    _6535 = _6536;
                }
                _6542 = _6543;
                _6534 = _6535;
            }
            _6541 = _6542;
            _6533 = _6534;
        }
        _6540 = _6541;
        _6532 = _6533;
    }
    float4 _4187 = mix(_AmbientTexture.sample(_AmbientTextureSmplr, _6532), _AmbientTexture.sample(_AmbientTextureSmplr, _6540), float4(fma(_3767, 7.0, -_3862)));
    float4 _4212 = (float4(-1.0, -0.0274999998509883880615234375, -0.572000026702880859375, 0.02199999988079071044921875) * _2339) + float4(1.0, 0.0425000004470348358154296875, 1.03999996185302734375, -0.039999999105930328369140625);
    float _4214 = _4212.x;
    float2 _4232 = (float2(-1.03999996185302734375, 1.03999996185302734375) * fma(fast::min(_4214 * _4214, exp2((-9.27999973297119140625) * _2473)), _4214, _4212.y)) + _4212.zw;
    float3 _3123 = (((((_2370 * _4232.x) + float3(_4232.y * fast::clamp(50.0 * _2370.y, 0.0, 1.0))) * (_4187.xyz / float3(_4187.w))) * fast::max(float3(_2502), ((((((_2370 * 2.040400028228759765625) - float3(0.3323999941349029541015625)) * _2502) + ((_2370 * (-4.79510021209716796875)) + float3(0.6417000293731689453125))) * _2502) + ((_2370 * 2.755199909210205078125) + float3(0.69029998779296875))) * _2502)) * buffer._AmbientIntensity) * 1.0;
    float3 _6575;
    float3 _6576;
    if (_2566 > 0.5)
    {
        float3 _4305 = fast::normalize(_2573 + _6492);
        float _4311 = fast::max(0.0, dot(_2081, _2573));
        float _4322 = fast::max(0.0, dot(_6492, _4305));
        float _4338 = fma(-_2473, _4311, fma(2.0 * _4322, _4322, -1.0));
        float _6564;
        if (_4338 >= 0.0)
        {
            _6564 = 1.0 / fast::max(_4311, _2473);
        }
        else
        {
            _6564 = 1.0;
        }
        float _4416 = fast::max(0.0, dot(_2081, _4305));
        float _4474 = 1.0 - _4311;
        float _4502 = fma(fma(_4416, _2450, -_4416), _4416, 1.0);
        float _4515 = 1.0 - _4322;
        float _4529 = _4515 * _4515;
        _6576 = _3123 + ((((((((_2370 + ((float3(1.0) - _2370) * ((_4529 * _4529) * _4515))) * (0.5 / (fma(_2445, fma(_2473, _4474, _4311), _2473 * fma(_2445, _4474, _4311)) + 9.9999997473787516355514526367188e-06))) * ((_2450 * 0.31830990314483642578125) / fma(_4502, _4502, 1.0000000116860974230803549289703e-07))) * 3.1415927410125732421875) * _4311) * buffer.u_DirLightsColor[0].xyz) * _2585) * 1.0);
        _6575 = _3116 + ((((_2363 * buffer.u_DirLightsColor[0].xyz) * _2585) * ((fma(((0.449999988079071044921875 * _2450) / fma(_2445, _2445, 0.0900000035762786865234375)) * _4338, _6564, 1.0 - ((0.5 * _2450) / fma(_2445, _2445, 0.3300000131130218505859375))) * fma(_2339, 0.5, 1.0)) * _4311)) * 1.0);
    }
    else
    {
        _6576 = _3123;
        _6575 = _3116;
    }
    float3 _6577;
    float3 _6578;
    if (_2600 > 0.5)
    {
        float _4544 = fast::max(0.0, dot(_2081, _2607));
        float3 _4580 = fast::normalize(_2607 + _6492);
        float _4585 = fast::max(0.0, dot(_2081, _4580));
        float _4639 = fma(fma(_4585, _2450, -_4585), _4585, 1.0);
        float _4652 = 1.0 - fast::max(0.0, dot(_6492, _4580));
        float _4666 = _4652 * _4652;
        _6578 = _6576 + ((((((((_2370 + ((float3(1.0) - _2370) * ((_4666 * _4666) * _4652))) * 0.25) * ((_2450 * 0.31830990314483642578125) / fma(_4639, _4639, 1.0000000116860974230803549289703e-07))) * 3.1415927410125732421875) * _4544) * buffer.u_DirLightsColor[1].xyz) * _2619) * 1.0);
        _6577 = _6575 + ((((_2363 * buffer.u_DirLightsColor[1].xyz) * _2619) * _4544) * 1.0);
    }
    else
    {
        _6578 = _6576;
        _6577 = _6575;
    }
    float3 _6579;
    float3 _6580;
    if (_2634 > 0.5)
    {
        float _4681 = fast::max(0.0, dot(_2081, _2641));
        float3 _4717 = fast::normalize(_2641 + _6492);
        float _4722 = fast::max(0.0, dot(_2081, _4717));
        float _4776 = fma(fma(_4722, _2450, -_4722), _4722, 1.0);
        float _4789 = 1.0 - fast::max(0.0, dot(_6492, _4717));
        float _4803 = _4789 * _4789;
        _6580 = _6578 + ((((((((_2370 + ((float3(1.0) - _2370) * ((_4803 * _4803) * _4789))) * 0.25) * ((_2450 * 0.31830990314483642578125) / fma(_4776, _4776, 1.0000000116860974230803549289703e-07))) * 3.1415927410125732421875) * _4681) * buffer.u_DirLightsColor[2].xyz) * _2653) * 1.0);
        _6579 = _6577 + ((((_2363 * buffer.u_DirLightsColor[2].xyz) * _2653) * _4681) * 1.0);
    }
    else
    {
        _6580 = _6578;
        _6579 = _6577;
    }
    float3 _6581;
    float3 _6582;
    if (_2675 > 0.5)
    {
        float _4818 = fast::max(0.0, dot(_2081, _2689));
        float3 _4854 = fast::normalize(_2689 + _6492);
        float _4859 = fast::max(0.0, dot(_2081, _4854));
        float _4913 = fma(fma(_4859, _2450, -_4859), _4859, 1.0);
        float _4926 = 1.0 - fast::max(0.0, dot(_6492, _4854));
        float _4940 = _4926 * _4926;
        _6582 = _6580 + (((((((((_2370 + ((float3(1.0) - _2370) * ((_4940 * _4940) * _4926))) * 0.25) * ((_2450 * 0.31830990314483642578125) / fma(_4913, _4913, 1.0000000116860974230803549289703e-07))) * 3.1415927410125732421875) * _4818) * buffer.u_PointLightsColor[0].xyz) * _2701) * _2721) * 1.0);
        _6581 = _6579 + (((((_2363 * buffer.u_PointLightsColor[0].xyz) * _2701) * _2721) * _4818) * 1.0);
    }
    else
    {
        _6582 = _6580;
        _6581 = _6579;
    }
    float3 _6583;
    float3 _6584;
    if (_2765 > 0.5)
    {
        float _4955 = fast::max(0.0, dot(_2081, _2779));
        float3 _4991 = fast::normalize(_2779 + _6492);
        float _4996 = fast::max(0.0, dot(_2081, _4991));
        float _5050 = fma(fma(_4996, _2450, -_4996), _4996, 1.0);
        float _5063 = 1.0 - fast::max(0.0, dot(_6492, _4991));
        float _5077 = _5063 * _5063;
        _6584 = _6582 + (((((((((_2370 + ((float3(1.0) - _2370) * ((_5077 * _5077) * _5063))) * 0.25) * ((_2450 * 0.31830990314483642578125) / fma(_5050, _5050, 1.0000000116860974230803549289703e-07))) * 3.1415927410125732421875) * _4955) * buffer.u_PointLightsColor[1].xyz) * _2791) * _2811) * 1.0);
        _6583 = _6581 + (((((_2363 * buffer.u_PointLightsColor[1].xyz) * _2791) * _2811) * _4955) * 1.0);
    }
    else
    {
        _6584 = _6582;
        _6583 = _6581;
    }
    float3 _6585;
    float3 _6586;
    if (_2857 > 0.5)
    {
        float _5092 = fast::max(0.0, dot(_2081, _2871));
        float3 _5128 = fast::normalize(_2871 + _6492);
        float _5133 = fast::max(0.0, dot(_2081, _5128));
        float _5187 = fma(fma(_5133, _2450, -_5133), _5133, 1.0);
        float _5200 = 1.0 - fast::max(0.0, dot(_6492, _5128));
        float _5214 = _5200 * _5200;
        _6586 = _6584 + (((((((((_2370 + ((float3(1.0) - _2370) * ((_5214 * _5214) * _5200))) * 0.25) * ((_2450 * 0.31830990314483642578125) / fma(_5187, _5187, 1.0000000116860974230803549289703e-07))) * 3.1415927410125732421875) * _5092) * buffer.u_SpotLightsColor[0].xyz) * _2883) * _2924) * 1.0);
        _6585 = _6583 + (((((_2363 * buffer.u_SpotLightsColor[0].xyz) * _2883) * _2924) * _5092) * 1.0);
    }
    else
    {
        _6586 = _6584;
        _6585 = _6583;
    }
    float3 _6587;
    float3 _6588;
    if (_2970 > 0.5)
    {
        float _5229 = fast::max(0.0, dot(_2081, _2984));
        float3 _5265 = fast::normalize(_2984 + _6492);
        float _5270 = fast::max(0.0, dot(_2081, _5265));
        float _5324 = fma(fma(_5270, _2450, -_5270), _5270, 1.0);
        float _5337 = 1.0 - fast::max(0.0, dot(_6492, _5265));
        float _5351 = _5337 * _5337;
        _6588 = _6586 + (((((((((_2370 + ((float3(1.0) - _2370) * ((_5351 * _5351) * _5337))) * 0.25) * ((_2450 * 0.31830990314483642578125) / fma(_5324, _5324, 1.0000000116860974230803549289703e-07))) * 3.1415927410125732421875) * _5229) * buffer.u_SpotLightsColor[1].xyz) * _2996) * _3037) * 1.0);
        _6587 = _6585 + (((((_2363 * buffer.u_SpotLightsColor[1].xyz) * _2996) * _3037) * _5229) * 1.0);
    }
    else
    {
        _6588 = _6586;
        _6587 = _6585;
    }
    float3 _3275 = _6587 + _6588;
    out.glResult = float4(pow(_3275.x, 0.4545449912548065185546875), pow(_3275.y, 0.4545449912548065185546875), pow(_3275.z, 0.4545449912548065185546875), buffer._AlbedoColor.w);
    return out;
}

